(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@clappr/core')) :
  typeof define === 'function' && define.amd ? define(['exports', '@clappr/core'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.TVsKeyMappingPlugin = {}, global.Clappr));
}(this, (function (exports, core) { 'use strict';

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function _isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _createSuper(Derived) {
    var hasNativeReflectConstruct = _isNativeReflectConstruct();

    return function _createSuperInternal() {
      var Super = _getPrototypeOf(Derived),
          result;

      if (hasNativeReflectConstruct) {
        var NewTarget = _getPrototypeOf(this).constructor;

        result = Reflect.construct(Super, arguments, NewTarget);
      } else {
        result = Super.apply(this, arguments);
      }

      return _possibleConstructorReturn(this, result);
    };
  }

  function _superPropBase(object, property) {
    while (!Object.prototype.hasOwnProperty.call(object, property)) {
      object = _getPrototypeOf(object);
      if (object === null) break;
    }

    return object;
  }

  function _get(target, property, receiver) {
    if (typeof Reflect !== "undefined" && Reflect.get) {
      _get = Reflect.get;
    } else {
      _get = function _get(target, property, receiver) {
        var base = _superPropBase(target, property);

        if (!base) return;
        var desc = Object.getOwnPropertyDescriptor(base, property);

        if (desc.get) {
          return desc.get.call(receiver);
        }

        return desc.value;
      };
    }

    return _get(target, property, receiver || target);
  }

  var KeyNames$5 = {};
  KeyNames$5.KEY_CODE_ENTER = 'ENTER';
  KeyNames$5.KEY_CODE_LEFT = 'LEFT';
  KeyNames$5.KEY_CODE_UP = 'UP';
  KeyNames$5.KEY_CODE_RIGHT = 'RIGHT';
  KeyNames$5.KEY_CODE_DOWN = 'DOWN';
  KeyNames$5.KEY_CODE_SPACE = 'SPACE';
  KeyNames$5.KEY_CODE_BACK_SPACE = 'BACK_SPACE';
  KeyNames$5.KEY_CODE_BREAK = 'BREAK';
  KeyNames$5.KEY_CODE_TAB = 'TAB';
  KeyNames$5.KEY_CODE_CLEAR = 'CLEAR';
  KeyNames$5.KEY_CODE_SHIFT = 'SHIFT';
  KeyNames$5.KEY_CODE_CTRL = 'CTRL';
  KeyNames$5.KEY_CODE_ALT = 'ALT';
  KeyNames$5.KEY_CODE_CAPS_LOCK = 'CAPS_LOCK';
  KeyNames$5.KEY_CODE_ESCAPE = 'ESCAPE';
  KeyNames$5.KEY_CODE_SPACE_BAR = 'SPACE_BAR';
  KeyNames$5.KEY_CODE_GUIDE = 'GUIDE';
  KeyNames$5.KEY_CODE_0 = '0';
  KeyNames$5.KEY_CODE_1 = '1';
  KeyNames$5.KEY_CODE_2 = '2';
  KeyNames$5.KEY_CODE_3 = '3';
  KeyNames$5.KEY_CODE_4 = '4';
  KeyNames$5.KEY_CODE_5 = '5';
  KeyNames$5.KEY_CODE_6 = '6';
  KeyNames$5.KEY_CODE_7 = '7';
  KeyNames$5.KEY_CODE_8 = '8';
  KeyNames$5.KEY_CODE_9 = '9';
  KeyNames$5.KEY_CODE_A = 'A';
  KeyNames$5.KEY_CODE_B = 'B';
  KeyNames$5.KEY_CODE_C = 'C';
  KeyNames$5.KEY_CODE_D = 'D';
  KeyNames$5.KEY_CODE_E = 'E';
  KeyNames$5.KEY_CODE_F = 'F';
  KeyNames$5.KEY_CODE_G = 'G';
  KeyNames$5.KEY_CODE_H = 'H';
  KeyNames$5.KEY_CODE_I = 'I';
  KeyNames$5.KEY_CODE_J = 'J';
  KeyNames$5.KEY_CODE_K = 'K';
  KeyNames$5.KEY_CODE_L = 'L';
  KeyNames$5.KEY_CODE_M = 'M';
  KeyNames$5.KEY_CODE_N = 'N';
  KeyNames$5.KEY_CODE_O = 'O';
  KeyNames$5.KEY_CODE_P = 'P';
  KeyNames$5.KEY_CODE_Q = 'Q';
  KeyNames$5.KEY_CODE_R = 'R';
  KeyNames$5.KEY_CODE_S = 'S';
  KeyNames$5.KEY_CODE_T = 'T';
  KeyNames$5.KEY_CODE_U = 'U';
  KeyNames$5.KEY_CODE_V = 'V';
  KeyNames$5.KEY_CODE_W = 'W';
  KeyNames$5.KEY_CODE_X = 'X';
  KeyNames$5.KEY_CODE_Y = 'Y';
  KeyNames$5.KEY_CODE_Z = 'Z';
  KeyNames$5.KEY_CODE_RED = 'RED';
  KeyNames$5.KEY_CODE_GREEN = 'GREEN';
  KeyNames$5.KEY_CODE_YELLOW = 'YELLOW';
  KeyNames$5.KEY_CODE_BLUE = 'BLUE';
  KeyNames$5.KEY_CODE_HELP = 'HELP';
  KeyNames$5.KEY_CODE_SEARCH = 'SEARCH';
  KeyNames$5.KEY_CODE_AUDIODESCRIPTION = 'AUDIODESCRIPTION';
  KeyNames$5.KEY_CODE_HD = 'HD';
  KeyNames$5.KEY_CODE_RECORD = 'RECORD';
  KeyNames$5.KEY_CODE_MINUS = 'MINUS';
  KeyNames$5.KEY_CODE_MENU = 'MENU';
  KeyNames$5.KEY_CODE_TOOLS = 'TOOLS';
  KeyNames$5.KEY_CODE_SOURCE = 'SOURCE';
  KeyNames$5.KEY_CODE_E_MANUAL = 'E_MANUAL';
  KeyNames$5.KEY_CODE_3D = '3D';
  KeyNames$5.KEY_CODE_EXTRA = 'EXTRA';
  KeyNames$5.KEY_CODE_PICTURE_SIZE = 'PICTURE_SIZE';
  KeyNames$5.KEY_CODE_SOCCER = 'SOCCER';
  KeyNames$5.KEY_CODE_TELE_TEXT = 'TELE_TEXT';
  KeyNames$5.KEY_CODE_MTS = 'MTS';
  KeyNames$5.KEY_CODE_PLAY = 'PLAY';
  KeyNames$5.KEY_CODE_PAUSE = 'PAUSE';
  KeyNames$5.KEY_CODE_PLAY_PAUSE = 'PLAY_PAUSE';
  KeyNames$5.KEY_CODE_STOP = 'STOP';
  KeyNames$5.KEY_CODE_PREV = 'PREV';
  KeyNames$5.KEY_CODE_NEXT = 'NEXT';
  KeyNames$5.KEY_CODE_FAST_FWD = 'FAST_FWD';
  KeyNames$5.KEY_CODE_REWIND = 'REWIND';
  KeyNames$5.KEY_CODE_INFO = 'INFO';
  KeyNames$5.KEY_CODE_SUBTITLE = 'SUBTITLE';
  KeyNames$5.KEY_CODE_BACK = 'BACK';
  KeyNames$5.KEY_CODE_EXIT = 'EXIT';
  KeyNames$5.KEY_CODE_VOLUME_UP = 'VOLUME_UP';
  KeyNames$5.KEY_CODE_CHANNEL_DOWN = 'CHANNEL_DOWN';
  KeyNames$5.KEY_CODE_CHANNEL_UP = 'CHANNEL_UP';
  KeyNames$5.KEY_CODE_VOLUME_DOWN = 'VOLUME_DOWN';
  KeyNames$5.KEY_CODE_MUTE = 'MUTE';
  KeyNames$5.KEY_CODE_CHANNEL_LIST = 'CHANNEL_LIST';
  KeyNames$5.KEY_CODE_PREV_CHANNEL = 'PREV_CHANNEL';
  KeyNames$5.KEY_CODE_CHANNEL_LIST = 'CHANNEL_LIST';

  var KeyNames$4 = {
    3: KeyNames$5.KEY_CODE_BREAK,
    8: KeyNames$5.KEY_CODE_BACK,
    9: KeyNames$5.KEY_CODE_TAB,
    12: KeyNames$5.KEY_CODE_CLEAR,
    13: KeyNames$5.KEY_CODE_ENTER,
    16: KeyNames$5.KEY_CODE_SHIFT,
    17: KeyNames$5.KEY_CODE_CTRL,
    18: KeyNames$5.KEY_CODE_ALT,
    19: KeyNames$5.KEY_CODE_PAUSE,
    20: KeyNames$5.KEY_CODE_CAPS_LOCK,
    27: KeyNames$5.KEY_CODE_ESCAPE,
    32: KeyNames$5.KEY_CODE_SPACE_BAR,
    37: KeyNames$5.KEY_CODE_LEFT,
    38: KeyNames$5.KEY_CODE_UP,
    39: KeyNames$5.KEY_CODE_RIGHT,
    40: KeyNames$5.KEY_CODE_DOWN,
    48: KeyNames$5.KEY_CODE_0,
    49: KeyNames$5.KEY_CODE_1,
    50: KeyNames$5.KEY_CODE_2,
    51: KeyNames$5.KEY_CODE_3,
    52: KeyNames$5.KEY_CODE_4,
    53: KeyNames$5.KEY_CODE_5,
    54: KeyNames$5.KEY_CODE_6,
    55: KeyNames$5.KEY_CODE_7,
    56: KeyNames$5.KEY_CODE_8,
    57: KeyNames$5.KEY_CODE_9,
    65: KeyNames$5.KEY_CODE_A,
    66: KeyNames$5.KEY_CODE_B,
    67: KeyNames$5.KEY_CODE_C,
    68: KeyNames$5.KEY_CODE_D,
    69: KeyNames$5.KEY_CODE_E,
    70: KeyNames$5.KEY_CODE_F,
    71: KeyNames$5.KEY_CODE_G,
    72: KeyNames$5.KEY_CODE_H,
    73: KeyNames$5.KEY_CODE_I,
    74: KeyNames$5.KEY_CODE_J,
    75: KeyNames$5.KEY_CODE_K,
    76: KeyNames$5.KEY_CODE_L,
    77: KeyNames$5.KEY_CODE_M,
    78: KeyNames$5.KEY_CODE_N,
    79: KeyNames$5.KEY_CODE_O,
    80: KeyNames$5.KEY_CODE_P,
    81: KeyNames$5.KEY_CODE_Q,
    82: KeyNames$5.KEY_CODE_R,
    83: KeyNames$5.KEY_CODE_S,
    84: KeyNames$5.KEY_CODE_T,
    85: KeyNames$5.KEY_CODE_U,
    86: KeyNames$5.KEY_CODE_V,
    87: KeyNames$5.KEY_CODE_W,
    88: KeyNames$5.KEY_CODE_X,
    89: KeyNames$5.KEY_CODE_Y,
    90: KeyNames$5.KEY_CODE_Z,
    112: KeyNames$5.KEY_CODE_SUBTITLE,
    113: KeyNames$5.KEY_CODE_PLAY,
    114: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    115: KeyNames$5.KEY_CODE_STOP,
    116: KeyNames$5.KEY_CODE_FAST_FWD,
    117: KeyNames$5.KEY_CODE_REWIND,
    166: KeyNames$5.KEY_CODE_BACK,
    402: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    403: KeyNames$5.KEY_CODE_RED,
    404: KeyNames$5.KEY_CODE_GREEN,
    405: KeyNames$5.KEY_CODE_YELLOW,
    406: KeyNames$5.KEY_CODE_BLUE,
    412: KeyNames$5.KEY_CODE_REWIND,
    413: KeyNames$5.KEY_CODE_STOP,
    415: KeyNames$5.KEY_CODE_PLAY,
    417: KeyNames$5.KEY_CODE_FAST_FWD,
    424: KeyNames$5.KEY_CODE_REWIND,
    425: KeyNames$5.KEY_CODE_FAST_FW
  };

  var KeyNames$3 = {
    4: KeyNames$5.KEY_CODE_LEFT,
    5: KeyNames$5.KEY_CODE_RIGHT,
    6: KeyNames$5.KEY_CODE_3,
    7: KeyNames$5.KEY_CODE_VOLUME_UP,
    9: KeyNames$5.KEY_CODE_5,
    10: KeyNames$5.KEY_CODE_6,
    11: KeyNames$5.KEY_CODE_VOLUME_DOWN,
    12: KeyNames$5.KEY_CODE_7,
    13: KeyNames$5.KEY_CODE_ENTER,
    14: KeyNames$5.KEY_CODE_9,
    17: KeyNames$5.KEY_CODE_0,
    18: KeyNames$5.KEY_CODE_MENU,
    19: KeyNames$5.KEY_CODE_PAUSE,
    20: KeyNames$5.KEY_CODE_GREEN,
    21: KeyNames$5.KEY_CODE_YELLOW,
    22: KeyNames$5.KEY_CODE_BLUE,
    27: KeyNames$5.KEY_CODE_MUTE,
    31: KeyNames$5.KEY_CODE_INFO,
    37: KeyNames$5.KEY_CODE_LEFT,
    38: KeyNames$5.KEY_CODE_UP,
    39: KeyNames$5.KEY_CODE_RIGHT,
    40: KeyNames$5.KEY_CODE_DOWN,
    48: KeyNames$5.KEY_CODE_0,
    49: KeyNames$5.KEY_CODE_1,
    50: KeyNames$5.KEY_CODE_2,
    51: KeyNames$5.KEY_CODE_3,
    52: KeyNames$5.KEY_CODE_4,
    53: KeyNames$5.KEY_CODE_5,
    54: KeyNames$5.KEY_CODE_6,
    55: KeyNames$5.KEY_CODE_7,
    56: KeyNames$5.KEY_CODE_8,
    57: KeyNames$5.KEY_CODE_9,
    69: KeyNames$5.KEY_CODE_REWIND,
    70: KeyNames$5.KEY_CODE_STOP,
    71: KeyNames$5.KEY_CODE_PLAY,
    72: KeyNames$5.KEY_CODE_FAST_FWD,
    74: KeyNames$5.KEY_CODE_PAUSE,
    88: KeyNames$5.KEY_CODE_BACK,
    98: KeyNames$5.KEY_CODE_2,
    101: KeyNames$5.KEY_CODE_1,
    108: KeyNames$5.KEY_CODE_RED,
    112: KeyNames$5.KEY_CODE_SUBTITLE,
    113: KeyNames$5.KEY_CODE_PLAY,
    114: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    115: KeyNames$5.KEY_CODE_STOP,
    116: KeyNames$5.KEY_CODE_FAST_FWD,
    117: KeyNames$5.KEY_CODE_REWIND,
    166: KeyNames$5.KEY_CODE_BACK,
    189: KeyNames$5.KEY_CODE_MINUS,
    402: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    403: KeyNames$5.KEY_CODE_RED,
    404: KeyNames$5.KEY_CODE_GREEN,
    405: KeyNames$5.KEY_CODE_YELLOW,
    406: KeyNames$5.KEY_CODE_BLUE,
    412: KeyNames$5.KEY_CODE_REWIND,
    413: KeyNames$5.KEY_CODE_STOP,
    415: KeyNames$5.KEY_CODE_PLAY,
    416: KeyNames$5.KEY_CODE_RECORD,
    417: KeyNames$5.KEY_CODE_FAST_FWD,
    424: KeyNames$5.KEY_CODE_REWIND,
    425: KeyNames$5.KEY_CODE_FAST_FW,
    427: KeyNames$5.KEY_CODE_CHANNEL_UP,
    428: KeyNames$5.KEY_CODE_CHANNEL_DOWN,
    447: KeyNames$5.KEY_CODE_VOLUME_UP,
    448: KeyNames$5.KEY_CODE_VOLUME_DOWN,
    449: KeyNames$5.KEY_CODE_MUTE,
    457: KeyNames$5.KEY_CODE_INFO,
    458: KeyNames$5.KEY_CODE_GUIDE,
    473: KeyNames$5.KEY_CODE_FAST_FWD,
    10009: KeyNames$5.KEY_CODE_BACK,
    10072: KeyNames$5.KEY_CODE_SOURCE,
    10073: KeyNames$5.KEY_CODE_CHANNEL_LIST,
    10135: KeyNames$5.KEY_CODE_TOOLS,
    10140: KeyNames$5.KEY_CODE_PICTURE_SIZE,
    10146: KeyNames$5.KEY_CODE_E_MANUAL,
    10182: KeyNames$5.KEY_CODE_EXIT,
    10190: KeyNames$5.KEY_CODE_PREV_CHANNEL,
    10195: KeyNames$5.KEY_CODE_MTS,
    10199: KeyNames$5.KEY_CODE_3D,
    10200: KeyNames$5.KEY_CODE_TELE_TEXT,
    10221: KeyNames$5.KEY_CODE_SUBTITLE,
    10225: KeyNames$5.KEY_CODE_SEARCH,
    10228: KeyNames$5.KEY_CODE_SOCCER,
    10232: KeyNames$5.KEY_CODE_PREV,
    10233: KeyNames$5.KEY_CODE_NEXT,
    10252: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    10253: KeyNames$5.KEY_CODE_EXTRA,
    29460: KeyNames$5.KEY_CODE_UP,
    29461: KeyNames$5.KEY_CODE_DOWN
  };

  var KeyNames$2 = {
    4: KeyNames$5.KEY_CODE_LEFT,
    5: KeyNames$5.KEY_CODE_RIGHT,
    6: KeyNames$5.KEY_CODE_3,
    7: KeyNames$5.KEY_CODE_VOLUME_UP,
    8: KeyNames$5.KEY_CODE_4,
    9: KeyNames$5.KEY_CODE_5,
    10: KeyNames$5.KEY_CODE_6,
    11: KeyNames$5.KEY_CODE_VOLUME_DOWN,
    12: KeyNames$5.KEY_CODE_7,
    13: KeyNames$5.KEY_CODE_8,
    14: KeyNames$5.KEY_CODE_9,
    17: KeyNames$5.KEY_CODE_0,
    20: KeyNames$5.KEY_CODE_GREEN,
    21: KeyNames$5.KEY_CODE_YELLOW,
    22: KeyNames$5.KEY_CODE_BLUE,
    27: KeyNames$5.KEY_CODE_MUTE,
    31: KeyNames$5.KEY_CODE_INFO,
    45: KeyNames$5.KEY_CODE_EXIT,
    48: KeyNames$5.KEY_CODE_0,
    49: KeyNames$5.KEY_CODE_1,
    50: KeyNames$5.KEY_CODE_2,
    51: KeyNames$5.KEY_CODE_3,
    52: KeyNames$5.KEY_CODE_4,
    53: KeyNames$5.KEY_CODE_5,
    54: KeyNames$5.KEY_CODE_6,
    55: KeyNames$5.KEY_CODE_7,
    56: KeyNames$5.KEY_CODE_8,
    57: KeyNames$5.KEY_CODE_9,
    65: KeyNames$5.KEY_CODE_CHANNEL_DOWN,
    68: KeyNames$5.KEY_CODE_CHANNEL_UP,
    69: KeyNames$5.KEY_CODE_REWIND,
    70: KeyNames$5.KEY_CODE_STOP,
    71: KeyNames$5.KEY_CODE_PLAY,
    72: KeyNames$5.KEY_CODE_FAST_FWD,
    74: KeyNames$5.KEY_CODE_PAUSE,
    75: KeyNames$5.KEY_CODE_TOOLS,
    88: KeyNames$5.KEY_CODE_BACK,
    98: KeyNames$5.KEY_CODE_2,
    101: KeyNames$5.KEY_CODE_1,
    108: KeyNames$5.KEY_CODE_RED,
    112: KeyNames$5.KEY_CODE_SUBTITLE,
    113: KeyNames$5.KEY_CODE_PLAY,
    114: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    115: KeyNames$5.KEY_CODE_STOP,
    116: KeyNames$5.KEY_CODE_FAST_FWD,
    117: KeyNames$5.KEY_CODE_REWIND,
    166: KeyNames$5.KEY_CODE_BACK,
    192: KeyNames$5.KEY_CODE_RECORD,
    259: KeyNames$5.KEY_CODE_PREV_CHANNEL,
    402: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    403: KeyNames$5.KEY_CODE_RED,
    404: KeyNames$5.KEY_CODE_GREEN,
    405: KeyNames$5.KEY_CODE_YELLOW,
    406: KeyNames$5.KEY_CODE_BLUE,
    412: KeyNames$5.KEY_CODE_REWIND,
    413: KeyNames$5.KEY_CODE_STOP,
    415: KeyNames$5.KEY_CODE_PLAY,
    417: KeyNames$5.KEY_CODE_FAST_FWD,
    473: KeyNames$5.KEY_CODE_FAST_FWD,
    29443: KeyNames$5.KEY_CODE_ENTER,
    29460: KeyNames$5.KEY_CODE_UP,
    29461: KeyNames$5.KEY_CODE_DOWN
  };

  var KeyNames$1 = {
    8: KeyNames$5.KEY_CODE_BACK,
    13: KeyNames$5.KEY_CODE_ENTER,
    19: KeyNames$5.KEY_CODE_PAUSE,
    37: KeyNames$5.KEY_CODE_LEFT,
    38: KeyNames$5.KEY_CODE_UP,
    39: KeyNames$5.KEY_CODE_RIGHT,
    40: KeyNames$5.KEY_CODE_DOWN,
    48: KeyNames$5.KEY_CODE_0,
    49: KeyNames$5.KEY_CODE_1,
    50: KeyNames$5.KEY_CODE_2,
    51: KeyNames$5.KEY_CODE_3,
    52: KeyNames$5.KEY_CODE_4,
    53: KeyNames$5.KEY_CODE_5,
    54: KeyNames$5.KEY_CODE_6,
    55: KeyNames$5.KEY_CODE_7,
    56: KeyNames$5.KEY_CODE_8,
    57: KeyNames$5.KEY_CODE_9,
    65: KeyNames$5.KEY_CODE_A,
    66: KeyNames$5.KEY_CODE_B,
    67: KeyNames$5.KEY_CODE_C,
    68: KeyNames$5.KEY_CODE_D,
    69: KeyNames$5.KEY_CODE_E,
    70: KeyNames$5.KEY_CODE_F,
    71: KeyNames$5.KEY_CODE_G,
    72: KeyNames$5.KEY_CODE_H,
    73: KeyNames$5.KEY_CODE_I,
    74: KeyNames$5.KEY_CODE_J,
    75: KeyNames$5.KEY_CODE_K,
    76: KeyNames$5.KEY_CODE_L,
    77: KeyNames$5.KEY_CODE_M,
    78: KeyNames$5.KEY_CODE_N,
    79: KeyNames$5.KEY_CODE_O,
    80: KeyNames$5.KEY_CODE_P,
    81: KeyNames$5.KEY_CODE_Q,
    82: KeyNames$5.KEY_CODE_R,
    83: KeyNames$5.KEY_CODE_S,
    84: KeyNames$5.KEY_CODE_T,
    85: KeyNames$5.KEY_CODE_U,
    86: KeyNames$5.KEY_CODE_V,
    87: KeyNames$5.KEY_CODE_W,
    88: KeyNames$5.KEY_CODE_X,
    89: KeyNames$5.KEY_CODE_Y,
    90: KeyNames$5.KEY_CODE_Z,
    112: KeyNames$5.KEY_CODE_SUBTITLE,
    113: KeyNames$5.KEY_CODE_PLAY,
    114: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    115: KeyNames$5.KEY_CODE_STOP,
    116: KeyNames$5.KEY_CODE_FAST_FWD,
    117: KeyNames$5.KEY_CODE_REWIND,
    166: KeyNames$5.KEY_CODE_BACK,
    402: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    403: KeyNames$5.KEY_CODE_RED,
    404: KeyNames$5.KEY_CODE_GREEN,
    405: KeyNames$5.KEY_CODE_YELLOW,
    406: KeyNames$5.KEY_CODE_BLUE,
    412: KeyNames$5.KEY_CODE_REWIND,
    413: KeyNames$5.KEY_CODE_STOP,
    415: KeyNames$5.KEY_CODE_PLAY,
    417: KeyNames$5.KEY_CODE_FAST_FWD,
    424: KeyNames$5.KEY_CODE_REWIND,
    425: KeyNames$5.KEY_CODE_FAST_FW,
    457: KeyNames$5.KEY_CODE_INFO,
    461: KeyNames$5.KEY_CODE_BACK
  };

  var KeyNames = {
    8: KeyNames$5.KEY_CODE_BACK,
    13: KeyNames$5.KEY_CODE_ENTER,
    19: KeyNames$5.KEY_CODE_PAUSE,
    37: KeyNames$5.KEY_CODE_LEFT,
    38: KeyNames$5.KEY_CODE_UP,
    39: KeyNames$5.KEY_CODE_RIGHT,
    40: KeyNames$5.KEY_CODE_DOWN,
    48: KeyNames$5.KEY_CODE_0,
    49: KeyNames$5.KEY_CODE_1,
    50: KeyNames$5.KEY_CODE_2,
    51: KeyNames$5.KEY_CODE_3,
    52: KeyNames$5.KEY_CODE_4,
    53: KeyNames$5.KEY_CODE_5,
    54: KeyNames$5.KEY_CODE_6,
    55: KeyNames$5.KEY_CODE_7,
    56: KeyNames$5.KEY_CODE_8,
    57: KeyNames$5.KEY_CODE_9,
    65: KeyNames$5.KEY_CODE_A,
    66: KeyNames$5.KEY_CODE_B,
    67: KeyNames$5.KEY_CODE_C,
    68: KeyNames$5.KEY_CODE_D,
    69: KeyNames$5.KEY_CODE_E,
    70: KeyNames$5.KEY_CODE_F,
    71: KeyNames$5.KEY_CODE_G,
    72: KeyNames$5.KEY_CODE_H,
    73: KeyNames$5.KEY_CODE_I,
    74: KeyNames$5.KEY_CODE_J,
    75: KeyNames$5.KEY_CODE_K,
    76: KeyNames$5.KEY_CODE_L,
    77: KeyNames$5.KEY_CODE_M,
    78: KeyNames$5.KEY_CODE_N,
    79: KeyNames$5.KEY_CODE_O,
    80: KeyNames$5.KEY_CODE_P,
    81: KeyNames$5.KEY_CODE_Q,
    82: KeyNames$5.KEY_CODE_R,
    83: KeyNames$5.KEY_CODE_S,
    84: KeyNames$5.KEY_CODE_T,
    85: KeyNames$5.KEY_CODE_U,
    86: KeyNames$5.KEY_CODE_V,
    87: KeyNames$5.KEY_CODE_W,
    88: KeyNames$5.KEY_CODE_X,
    89: KeyNames$5.KEY_CODE_Y,
    90: KeyNames$5.KEY_CODE_Z,
    112: KeyNames$5.KEY_CODE_SUBTITLE,
    113: KeyNames$5.KEY_CODE_PLAY,
    114: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    115: KeyNames$5.KEY_CODE_STOP,
    116: KeyNames$5.KEY_CODE_FAST_FWD,
    117: KeyNames$5.KEY_CODE_REWIND,
    166: KeyNames$5.KEY_CODE_BACK,
    402: KeyNames$5.KEY_CODE_PLAY_PAUSE,
    403: KeyNames$5.KEY_CODE_RED,
    404: KeyNames$5.KEY_CODE_GREEN,
    405: KeyNames$5.KEY_CODE_YELLOW,
    406: KeyNames$5.KEY_CODE_BLUE,
    412: KeyNames$5.KEY_CODE_REWIND,
    413: KeyNames$5.KEY_CODE_STOP,
    415: KeyNames$5.KEY_CODE_PLAY,
    417: KeyNames$5.KEY_CODE_FAST_FWD,
    424: KeyNames$5.KEY_CODE_REWIND,
    425: KeyNames$5.KEY_CODE_FAST_FW
  };

  /* eslint-disable camelcase */
  var KeyMap = {
    browser: KeyNames$4,
    samsung_tizen: KeyNames$3,
    samsung_orsay: KeyNames$2,
    lg_webos: KeyNames$1,
    panasonic: KeyNames
  };

  core.Events.register('CORE_SMART_TV_KEY_PRESSED');
  core.Events.register('CONTAINER_SMART_TV_KEY_PRESSED');

  var TVsKeyMappingPlugin = /*#__PURE__*/function (_CorePlugin) {
    _inherits(TVsKeyMappingPlugin, _CorePlugin);

    var _super = _createSuper(TVsKeyMappingPlugin);

    function TVsKeyMappingPlugin(core$1) {
      var _this;

      _classCallCheck(this, TVsKeyMappingPlugin);

      _this = _super.call(this, core$1);
      _this.start = _this.start.bind(_assertThisInitialized(_this));
      _this.stop = _this.stop.bind(_assertThisInitialized(_this));
      _this.enableLog = _this.enableLog.bind(_assertThisInitialized(_this));
      _this.disableLog = _this.disableLog.bind(_assertThisInitialized(_this));
      _this._triggerKeyDownEvents = _this._triggerKeyDownEvents.bind(_assertThisInitialized(_this));
      _this._onPressedKey = _this._onPressedKey.bind(_assertThisInitialized(_this));
      _this._deviceName = _this.options.tvsKeyMapping && _this.options.tvsKeyMapping.deviceToMap;
      _this._deviceName ? _this.start(_this._deviceName) : core.Log.warn(_this.name, 'tvsKeyMapping.deviceToMap was not configured. Call the start method with a valid name to activate the plugin.');
      return _this;
    }

    _createClass(TVsKeyMappingPlugin, [{
      key: "name",
      get: function get() {
        return 'tvs_key_mapping';
      }
    }, {
      key: "supportedVersion",
      get: function get() {
        return {
          min: core.version
        };
      }
    }, {
      key: "start",
      value: function start(device) {
        if (!device) return core.Log.warn(this.name, 'No one device name was received. The plugin will not fire events as expected.');
        if (!KeyMap[device]) return core.Log.warn(this.name, 'The device name is not valid. The plugin will not fire events as expected.');
        this._deviceName = device;
        document.addEventListener('keydown', this._triggerKeyDownEvents);
      }
    }, {
      key: "_triggerKeyDownEvents",
      value: function _triggerKeyDownEvents(ev) {
        var keyName = this._getKeyNameFromEvent(ev);

        if (typeof keyName === 'undefined') return core.Log.warn(this.name, 'The key code is not mapped. The plugin will not fire events as expected.');
        this.core.trigger(core.Events.Custom.CORE_SMART_TV_KEY_PRESSED, keyName, {
          keyName: keyName,
          keyEvent: ev
        });
        this.core.activeContainer && this.core.activeContainer.trigger(core.Events.Custom.CONTAINER_SMART_TV_KEY_PRESSED, keyName, {
          keyName: keyName,
          keyEvent: ev
        });
      }
    }, {
      key: "_getKeyNameFromEvent",
      value: function _getKeyNameFromEvent(ev) {
        var keyMapForDevice = KeyMap[this._deviceName];
        var keyName = keyMapForDevice && keyMapForDevice[ev.keyCode];
        return keyName;
      }
    }, {
      key: "stop",
      value: function stop() {
        document.removeEventListener('keydown', this._triggerKeyDownEvents);
      }
    }, {
      key: "enableLog",
      value: function enableLog() {
        if (!this._deviceName) return core.Log.warn(this.name, 'No one device name was configured. Logging is not enabled.');
        document.addEventListener('keydown', this._onPressedKey);
      }
    }, {
      key: "_onPressedKey",
      value: function _onPressedKey(ev) {
        core.Log.info(this.name, "The key pressed has the code ".concat(ev.keyCode, " and is mapped to the ").concat(this._getKeyNameFromEvent(ev), " value."));
      }
    }, {
      key: "disableLog",
      value: function disableLog() {
        document.removeEventListener('keydown', this._onPressedKey);
      }
    }, {
      key: "destroy",
      value: function destroy() {
        this.stop();
        this.disableLog();

        _get(_getPrototypeOf(TVsKeyMappingPlugin.prototype), "destroy", this).call(this);
      }
    }]);

    return TVsKeyMappingPlugin;
  }(core.CorePlugin);

  exports.KeyNames = KeyNames$5;
  exports.Watcher = TVsKeyMappingPlugin;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
